#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_xml_loads4xi.py">
#<abstract4xi abstract = "provides the function _xml_loads4xi"/>
#<refer4xi reference = "connection.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "_xml_loads compared to _xml_loads of connection.py and found no changes due to Rel 7.21"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_xml_loads4xi']
#"
#/>
 

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi   

import socket
import errno
import time
import tempfile
import itertools
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import connection
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import xmllistener4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "xml-loads4xixml-loads4xi" usage = "
#   connection.py 
#   xmlclient4xi.py
#   xmllistener4xi.py
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _xml_loads4xi(s):
    '''
    loads XML
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
    class2print = "_xml_loads4xi"
    method2print = "_xml_loads4xi"

    
    message2print = "{started" + "; xml-loads4xi-started: " + str(_xml_loads4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{passed" + "; string-passed-to-xml-loads4xi: " + str(s) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    
            
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{passing" + "; string-decode-passing-to-xmlrpclib4xi-loads-by-xml-loads4xi: " + str(s.decode('utf8')) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
 
           
    (obj,), method = xmlrpclib4xi.loads(s.decode('utf8'))

    message2print = "{got" + "; object-got-by-xml-loads4xi: " + str(obj)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)

    message2print = "{got" + "; method-got-by-xml-loads4xi: " + str(method)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
                    
            
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------           
    message2print = "{returning" + "; object-returning-by-xml-loads4xi: " + str(obj) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
                
        
    return obj
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_xml_loads4xi.txt
#   sense-test-xml-loads4xi.xml
#   reason-test-xml-loads4xi.xml
#   ace-test-xml-loads4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _xml_loads4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


